<?php
/**
 * @version		2.2
 * @package		Example K2 Plugin (K2 plugin)
 * @author		JoomlaWorks - http://www.joomlaworks.net
 * @copyright	Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die ;

// Load the K2 Plugin API
JLoader::register('K2Plugin', JPATH_ADMINISTRATOR.'/components/com_k2/lib/k2plugin.php');
jimport( 'joomla.plugin.plugin' );
include_once (JPATH_ROOT . DS . 'plugins' . DS . 'k2' . DS . 'k2posting' . DS . 'json' . DS . 'jsonwrapper.php');
require_once (JPATH_ROOT . DS . 'components' . DS . 'com_k2' . DS . 'helpers' . DS . 'route.php');

// Initiate class to hold plugin events
class plgK2k2posting extends K2Plugin
{
	protected $access_token = '';
	protected $owner_id  = '';
	protected $category = '';

	// Some params
	var $pluginName = 'k2posting';
	var $pluginNameHumanReadable = 'Кросспостинг новостей Вконтакте';

	function plgK2k2posting(&$subject, $params)
	{
		jimport('joomla.html.parameter');

		$mainframe = JFactory::getApplication();
	    parent::__construct($subject, $params);

	    $plugin =& JPluginHelper::getPlugin('k2', 'k2posting');
	    $pluginParams = new JRegistry($plugin->params);

	    $this->access_token = $pluginParams->get('access_token', '');
	    $this->owner_id = $pluginParams->get('id', '');
	    $this->album_id = $pluginParams->get('album', '');
	    $this->category = explode(',', $pluginParams->get('category', ''));
	}

	function onAfterK2Save(&$item, $isNew)		{

	    $mainframe = JFactory::getApplication();
	    $plugins = new K2Parameter($item->plugins, '', $this->pluginName);

	    $hour = $plugins->get('posting-time');
	    
	    if($hour) {
			$posting_time = strtotime($hour);
		} else {
			$posting_time = '';
		}

	    if($this->access_token == '' || $this->owner_id == '')	{
			JError::raiseWarning('1', 'AutopostVK error - AutopostVK is not configured properly. Please go to Plugin Manager and add your VK token, ID and category articles');
			return false;
	    }

	    $post = true;
	    foreach($this->category as $val) {
	    	if ($item->catid == (int) $val) {
	    		$post = false;
	    		break;
	    	}
	    }
	    if($isNew && $post)	{
			$this->postMessage($item, $this->access_token, $this->owner_id, $posting_time, $this->album_id);
	    }

	    return true;
	}

	private function postMessage($item, $access_token, $owner_id, $post_date, $aid)	{
	 	 
	 	$mainframe = JFactory::getApplication();
	 	$link = $this->getURL($item);
	 	$message = $item->title.'.

	 	'.strip_tags($item->introtext);
	 	$request = "https://api.vk.com/method/wall.post";
	 	$image = JPATH_ROOT.'/media/k2/items/cache/'.md5("Image".$item->id).'_XL.jpg';
		$params = array(
	 			'owner_id'     => -$owner_id,
	 			'message'      => $message,
	 			'from_group'   => '1',
	 			'attachments'  => $link,
	 			'access_token' => $access_token,
	 			'publish_date' => $post_date);
		if ($image !== null)	{
			$imageData = $this->uploadImage($this->getUploadServer($owner_id, $aid), $image);
			$imageID = $this->savePhoto($imageData, $owner_id, $item, $aid);
			$photo = 'photo-'.$owner_id.'_'.$imageID;
			$params[attachments] = $photo . "," . $link;
		}

	 	$result = $this->callMethod($request, $params);
	 	$mainframe->enqueueMessage('AutopostVK: ' . $result);
	 	$mainframe->enqueueMessage('imageID - '.$photo);	 	 
	}

	private function getUploadServer($gid, $aid)		{
	 	$request = "https://api.vk.com/method/photos.getUploadServer";
	 	$params = array (
	 			'album_id' 	=> $aid,
	 			'group_id'  => $gid,
	 			'access_token'  => $this->access_token);
	 	$result = json_decode($this->callMethod($request, $params));
	 	$upload_url = $result->response->upload_url;
	 	
	 	return $upload_url;
	}

	private function savePhoto($imageData, $gid, $item, $aid)	{
	 	$request = "https://api.vk.com/method/photos.save";
	 	$params = array (
	 			'album_id' 		=> $aid,
	 			'group_id'  	=> $gid,
	 			'server' 		=> $imageData->server,
	 			'photos_list'  	=> $imageData->photos_list,
	 			'hash'	 		=> $imageData->hash,
	 			'caption'		=> $item->title.'. 

	 			'.mb_substr(strip_tags($item->introtext), 0, 128, 'UTF-8').'...

	 			Ссылка: '.$this->getURL($item),
	 			'access_token'	=> $this->access_token);
	 	$result = json_decode($this->callMethod($request, $params));
	 	
	 	return $result->response['0']->pid;
	}
	 
	private function uploadImage($uploadUrl, $image)	{
	 	$params = array(
	 			'file1' => '@' .$image);
	 	$result = json_decode($this->callMethod($uploadUrl, $params));
	 	
	 	return $result;
	} 
	 
	private function getImage($item)	{
		$src = 'media/k2/items/cache/'.md5("Image".$item->id).'_XL.jpg';
	 			if (!preg_match("/http/i", $src))	
	 				$image = preg_replace("/^https?:\/\/[^\/]*/i", $_SERVER[DOCUMENT_ROOT], JURI::root() . $src);	
	 	return $image;
	}
	 
	private function getCategory($id)	{
	 	$row =& JTable::getInstance('category');
	 	$row->load($id);
	 
	 	return $row;
	}
	 
	private function getURL($item)	{
	 	$cat =& $this->getCategory($item->catid);

	 	$input = JFactory::getApplication()->input;
		$categoryid = ($input->getCmd('view', '')=='item')?  $input->getCmd('catid', ''): $input->getCmd('id', '');
		echo $categoryid;
	 		
	 	$cat_name	= '';
	 	$cat_slug	= 0;
	 	$id_slug	= $item->id . ':' . JFilterOutput::stringURLSafe($item->alias);
	 
	 	if ($cat && (0 < $cat->id)) {
	 		$cat_name = $cat->title;
	 		$cat_slug = $cat->id . ':' . JFilterOutput::stringURLSafe($cat->alias);
	 	}

	 	//Non SEF URL
	 	$link = JRoute::_(K2HelperRoute::getItemRoute($id_slug, $cat_slug));

	 	$app =& JFactory::getApplication();
	 	if($app->getCfg('sef')){
	 		$router = new JRouterSite(array('mode'=>JROUTER_MODE_SEF));
	 		// SEF URL
	 		$link = JRoute::_('index.php?option=com_k2&view=item&id='.$item->id);
	 		$link = $router->build($link)->toString(array('path', 'query', 'fragment'));
	 	}
	 	
	 	if(JPATH_BASE == JPATH_ADMINISTRATOR)
	 	 	$link = str_replace(JURI::root(true).'/administrator/', '', $link);
	 	else
	 	 	$link = str_replace(JURI::root(true).'/', '', $link);
	 	$link = JURI::root().$link;

	 	$link = str_replace('administrator/', '', $link);
	 	
	 	return $link;
	}
	 
	private function callMethod($request, $params)		{
	 	 
	 	$c=curl_init();
	 	curl_setopt($c, CURLOPT_URL, $request);
	 	curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
	 	curl_setopt($c, CURLOPT_FOLLOWLOCATION, true);
	 	curl_setopt($c, CURLOPT_POST, true);
	 	curl_setopt($c, CURLOPT_POSTFIELDS, $params);
	 	curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 10);
	 	curl_setopt($c, CURLOPT_TIMEOUT, 30);
	 	curl_setopt($c, CURLOPT_SSL_VERIFYPEER, false);
	 	$result = curl_exec($c);
	 	if($result === false)	{
	 		$result = curl_error($c);
	 	}
	 	curl_close($c);
	 
	 	return $result;
	}

}